<?php
declare(strict_types=1);

namespace Inti\Wp\Provider;

use Inti\Provider\Service\ProviderManager;
use Inti\Wp\Plugin\Service\PluginManager;

/**
 * Class ConfigProvider
 *
 * @package Inti\Wp\Provider
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-wp-provider
 */
final class ConfigProvider
{
    public function __invoke(): array
    {
        return [
            'wp' => [
                'plugins' => [
                    Plugin\ProvideMetadata::class,
                    Plugin\ProvidePosts::class,
                    Plugin\ProvideTerms::class,
                ],
            ],

            PluginManager::class => [
                'factories' => [
                    Plugin\ProvideMetadata::class => Plugin\Factory\ProviderPluginFactory::class,
                    Plugin\ProvidePosts::class => Plugin\Factory\ProviderPluginFactory::class,
                    Plugin\ProvideTerms::class => Plugin\Factory\ProviderPluginFactory::class,
                ],
            ],

            'dependencies' => [
                'delegators' => [
                    ProviderManager::class => [
                        Container\RegisterWpProviders::class,
                    ],
                ],
            ],
        ];
    }
}
