<?php
declare(strict_types=1);

namespace Inti\Wp\Provider\Container;

use Interop\Container\ContainerInterface;
use Inti\Provider\Service\ProviderManagerInterface;
use Laminas\ServiceManager\Factory\DelegatorFactoryInterface;

/**
 * Class ProviderManagerDelegator
 *
 * @package Inti\Wp\Provider\Container
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-wp-provider
 */
final class RegisterWpProviders implements DelegatorFactoryInterface
{
    public function __invoke(ContainerInterface $container, $name, callable $callback, array $options = null): ProviderManagerInterface
    {
        $config = $container->has('config') ? $container->get('config') : [];

        /** @var ProviderManagerInterface $provider */
        $provider = $callback();
        $provider->registerProviders($config['wp']['providers'] ?? []);

        return $provider;
    }
}
