<?php
declare(strict_types=1);

namespace IntiTest\Wp\Provider\Mock;

use Inti\Provider\Type\TypeInterface;
use Inti\Wp\Provider\Metadata\AbstractMetadataProvider;
use Inti\Wp\Provider\Metadata\MetadataProviderInterface;
use Inti\Wp\Provider\Type\Post\Post;

/**
 * Class PostMetadataProvider
 *
 * @package IntiTest\Wp\Provider\Mock
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-bartog
 */
class PostMetadataProvider extends AbstractMetadataProvider implements MetadataProviderInterface
{
    protected array $meta_keys = [
        '_meta_key1',
        '_meta_key2',
    ];

    protected array $metadata = [
        1 => [
            '_meta_key1' => 'meta value 1-1',
            '_meta_key2' => 'meta value 1-2',
        ],
    ];

    public function getProvidedType(): TypeInterface
    {
        return Post::instance();
    }
}
